package cn.cecep.talroad.service.impl;

import cn.cecep.talroad.domain.MonDevBlOther;
import cn.cecep.talroad.mapper.MonDevBlOtherMapper;
import cn.cecep.talroad.service.IMonDevBlOtherService;
import cn.cecep.talroad.vo.MonDevBlVO;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;




/**
 * 设备数据-玻璃-其它时间 保存设备的小时以上的数据Service业务层处理
 *
 * @author szhpt
 * @date 2023-01-10*/
@Service
public class MonDevBlOtherServiceImpl extends ServiceImpl<MonDevBlOtherMapper,MonDevBlOther> implements IMonDevBlOtherService
{
    @Autowired
    private MonDevBlOtherMapper monDevBlOtherMapper;

    /**
     * 查询设备数据-玻璃-其它时间 保存设备的小时以上的数据列表
     *
     * @param monDevBlOther 设备数据-玻璃-其它时间 保存设备的小时以上的数据
     * @return 设备数据-玻璃-其它时间 保存设备的小时以上的数据
     */
    @Override
    public List<MonDevBlOther> selectMonDevBlOtherList(MonDevBlOther monDevBlOther)
    {
        return monDevBlOtherMapper.selectMonDevBlOtherList(monDevBlOther);
    }

    @Override
    public List<MonDevBlVO> getDataPage(String factoryId, List<String> deviceIds, String timeType, String startTime, String endTime, String orderField, String orderType, Page page) {
        QueryWrapper<MonDevBlVO> queryWrapper = new QueryWrapper<MonDevBlVO>()
                .eq("r.factory_id", factoryId)
                .in("r.device_id", deviceIds)
                .eq("r.time_type", timeType)
                .ge("r.data_time", startTime)
                .le("r.data_time", endTime)
                .orderBy(StringUtils.isNotEmpty(orderField), "asc".equals(orderType), orderField, "r.data_id");
        return baseMapper.getDataPage(page, queryWrapper);
    }

}
